package io.controller;


import io.common.constant.Constant;
import io.common.page.PageData;
import io.common.utils.Result;
import io.common.validator.AssertUtils;
import io.common.validator.ValidatorUtils;
import io.common.validator.group.AddGroup;
import io.common.validator.group.DefaultGroup;
import io.common.validator.group.UpdateGroup;
import io.modules.item.dto.DepartmentsDTO;
import io.modules.item.service.DepartmentsService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.Parameters;
import io.swagger.v3.oas.annotations.enums.ParameterIn;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;


/**
 * 科室管理
 */
@RestController
@RequestMapping("api/departments")
@Tag(name="科室管理")
@CrossOrigin
public class DepartmentsController {
    @Autowired
    private DepartmentsService departmentsService;

    @GetMapping("page")
    @Operation(summary = "分页")
    @Parameters({
        @Parameter(name = Constant.PAGE, description = "当前页码，从1开始", in = ParameterIn.QUERY, required = true, ref="int") ,
        @Parameter(name = Constant.LIMIT, description = "每页显示记录数", in = ParameterIn.QUERY,required = true, ref="int") ,
        @Parameter(name = Constant.ORDER_FIELD, description = "排序字段", in = ParameterIn.QUERY, ref="String") ,
        @Parameter(name = Constant.ORDER, description = "排序方式，可选值(asc、desc)", in = ParameterIn.QUERY, ref="String")
    })

    public Result<PageData<DepartmentsDTO>> page(@Parameter(hidden = true) @RequestParam Map<String, Object> params){
        PageData<DepartmentsDTO> page = departmentsService.page(params);
        return new Result<PageData<DepartmentsDTO>>().ok(page);
    }


    @GetMapping("list")
    @Operation(summary = "分页")
    public Result<List<DepartmentsDTO>> list(@Parameter(hidden = true) @RequestParam Map<String, Object> params){
        List<DepartmentsDTO> page = departmentsService.list(params);
        return new Result<List<DepartmentsDTO>>().ok(page);
    }

    @GetMapping("{id}")
    @Operation(summary = "信息")
    public Result<DepartmentsDTO> get(@PathVariable("id") Long id){
        DepartmentsDTO data = departmentsService.get(id);

        return new Result<DepartmentsDTO>().ok(data);
    }

    @PostMapping
    @Operation(summary = "保存")
    public Result save(@RequestBody DepartmentsDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, AddGroup.class, DefaultGroup.class);

        departmentsService.save(dto);

        return new Result();
    }

    @PutMapping
    @Operation(summary = "修改")
    public Result update(@RequestBody DepartmentsDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, UpdateGroup.class, DefaultGroup.class);

        departmentsService.update(dto);

        return new Result();
    }

    @DeleteMapping("{id}")
    @Operation(summary = "删除")
    public Result delete(@PathVariable Long id) {
        Long[] ids = new Long[]{id};
        //效验数据
        AssertUtils.isArrayEmpty(ids, "id");
        departmentsService.delete(ids);
        return new Result();
    }

}
